//Progam: viper1k.p

format zx81
;labelusenumeric
;LISTON

PAL	  EQU 55
NTSC	  EQU 31
SLOW_MODE EQU $40
FAST_MODE EQU $00

ORG	 $4009
VERSN	 db $00
E_PPC	 dw $0000
D_FILE	 dw DFILE_ADDR
DF_CC	 dw DFILE_ADDR+1
VARS	 dw VARS_ADDR
DEST	 dw $0000
E_LINE	 dw WORKSPACE
CH_ADD	 dw WORKSPACE+4
X_PTR	 dw $0000
STKBOT	 dw PROGEND
STKEND	 dw PROGEND
BERG	 db $00
MEM	 dw MEMBOT
UNUSED1  db $00
DF_SZ	 db $02
S_TOP	 dw $0000
LAST_K	 dw $FFFF
DEBOUNCE db $FF
MARGIN	 db PAL
NXTLIN	 dw AUTORUN
OLDPPC	 dw $0000
FLAGX	 db $00
STRLEN	 dw $0000
T_ADDR	 dw $0C8D
SEED	 dw $0000
FRAMES	 dw $B586
COORDS	 db $00
	 db $00
PR_CC	 db $BC       ; 188
S_POSN	 db $21       ; 33
	 db $18       ; 24
CDFLAG	 db SLOW_MODE
PRBUFF:
  STORDE:  DW 0
  STORMO:  DW 0
  STORMI:  DW 0
  SHIPS:   DB 0
  MFLAG:   DB 0
  SCORE:   DW 0
  STATUS:  DW 0
  dfactor: DW $0400
	 db $00,$00
	 db $00,$00
	 db $00,$00,$00,$00,$00,$00,$00
	 db $00,$00,$00,$00,$00,$00,$00
	 db $76
MEMBOT	 db $00,$00,$00,$00,$00,$00,$00,$00
	 db $00,$00,$00,$00,$00,$00,$00,$00
	 db $00,$00,$00,$00,$00,$00,$00,$00
	 db $00,$00,$00,$00,$00,$00
UNUSED2  dw $0000

autoline 1
     REM F)IRE 9)CHANGE
    // SLOW
     FOR F = 1 TO 11
     PRINT "                                ";
     NEXT F
AUTORUN:
     RAND USR #START
     REM _asm
     // SAM_JR aka VIPER-1 1982
     LINES    EQU     10
     _MONXER  EQU     $97 ;$80 ;
     _PLAYER  EQU     $83 ;$83 ;
     _MISSILE EQU     $0B ;$85 ;   $0B; "
     _BKGRND  EQU     $08 ;$08 ;
     _BG_PLYR EQU     _BKGRND
     _SQUASH  EQU     $17 ;$17 ;*
     _LIVES   EQU     3
     _DELAY   EQU     $06 ;$60 ;$06 for PAL

     START:  LD      HL,0000H
	     LD      (SCORE),HL
	     LD      L,_LIVES
	     LD      (SHIPS),HL
	     LD      HL,(D_FILE)
	   //LD      DE,10       ';START MONXER AT 10
	   //ADD     HL,DE
	     INC     HL 	  ;START MONXER AT 2
	     INC     HL
	     INC     HL
	     LD      (STORMO),HL
	     LD      (HL),_MONXER
	     LD      DE,33*LINES
	     ADD     HL,DE
	     LD      (STORDE),HL
	     LD      C,76H
     LOOP:   LD      HL,(STORDE)
	     LD      (HL),_PLAYER
	     CALL    MONXER
	     LD      A,(MFLAG)	      ; if active call missile
	     OR      A
	     CALL    NZ,MISSILE
	     CALL    DELAY
	     IN      A,(0FEH)
	     BIT     0,A
	     RET     Z
	     LD      HL,STATUS
	     BIT     1,A
	     PUSH    AF
	     JR      NZ,@F
	     BIT     1,(HL)
	     CALL    Z,CHANGE
	 @@: POP     AF
     STAT:   SET     1,(HL)
	     JR      Z,@F
	     RES     1,(HL)
	 @@: BIT     3,A
	     CALL    Z,FIRE
	     CALL    MOVE
	     CALL    Z,CHANGE
	     JR      LOOP

     CHANGE: LD      HL,STATUS
	     LD      A,01
	     XOR     (HL)
	     LD      (HL),A
	     RET

     MOVE:   LD      HL,STATUS
	     BIT     0,(HL)
	     LD      HL,(STORDE)
	     JR      Z,LEFT
     RIGHT:  INC     HL
	     LD      A,(HL)
	     DEC     HL
	     CP      C
	     RET     Z
	     LD      (HL),_BG_PLYR
	     INC     HL
	     LD      (STORDE),HL
	     RET
     LEFT:   DEC     HL
	     LD      A,(HL)
	     INC     HL
	     CP      C
	     RET     Z
	     LD      (HL),_BG_PLYR
	     DEC     HL
	     LD      (STORDE),HL
	     RET

     DELAY:  LD      D,04
	   //LD      DE,(dfactor)
     DELAY2: DEC     DE
	     LD      A,D
	     OR      E
	     JR      NZ,DELAY2
	     RET

     MONXER: LD      HL,(STORMO)
	     LD      A,(HL)
	     CP      _PLAYER
	     JR      Z,COLIDE
	     LD      A,(4034H)	  ;FRAMES
	     RRA
	     RET     C
	     LD      (HL),_BKGRND
	     INC     HL
	     LD      A,(HL)
	     CP      C
	     JR      NZ,GORF
	     INC     HL
       GORF: LD      A,(HL)
	     CP      _PLAYER
	     LD      (STORMO),HL
	     LD      (HL),_MONXER
	     RET     NZ
     COLIDE: LD      A,(SHIPS)
	     LD      HL,(STORDE)
	     LD      (HL),_SQUASH
	   //LD      HL,0100
	   //LD      (dfactor),HL ; or dfgetin,HL ?
	     DEC     A
	     LD      (SHIPS),A
	     JR      NZ,C2
	     POP     HL
	     RET
	C2:  LD      D,_DELAY
	     CALL    DELAY2
	     LD      HL,(D_FILE)
	     NOP
	     LD      DE,LINES
	     ADD     HL,DE
	     JR      GORF

     FIRE:   LD      A,(MFLAG)	   ; MFLAG Counts line missile is at
	     OR      A
	     RET     NZ 	   ; Ret if missile already active
	     LD      A,LINES+1
	     LD      (MFLAG),A
	     LD      HL,(STORDE)
	     LD      (STORMI),HL
	     RET     

     MISSILE:LD      HL,(STORMI)
	     LD      A,(HL)
	     CP      _MONXER
	     JR      Z,M2
	     LD      (HL),_BKGRND
	 M2: LD      DE,33
	     OR      A
	     SBC     HL,DE
	     LD      (STORMI),HL
	     LD      A,(MFLAG)
	     DEC     A
	     LD      (MFLAG),A
	     RET     Z		    ; RET if Missile Travel completed
	     LD      A,(HL)
	     CP      _MONXER
	     LD      (HL),_MISSILE
	     RET     NZ 	    ; RET IF NO HIT
     HIT:    LD      (HL),_SQUASH
	     LD      HL,(D_FILE)    ; RESET MONXER
	     LD      DE,LINES
	     ADD     HL,DE
	     LD      (STORMO),HL
	     LD      (HL),_MONXER
     SCORING:LD      HL,(SCORE)
	     ADD     A,L
	     DAA     
	     LD      L,A
	     JR      NC,CORE
	     LD      A,H
	     ADD     A,01H
	     DAA     
	     LD      H,A
     CORE:   LD      (SCORE),HL
	     PUSH    HL
	     LD      HL,(D_FILE)
	   //LD      DE,LINES+33*11 ;PRINT SCORE N LINES DOWN (BELOW PLAYSCREEN)
	   //ADD     HL,DE
	     INC     HL 	    ;PRINT SCORE AT TOP OF SCREEN
	     POP     DE
	     LD      A,D
	     AND     15
	     ADD     A,28
	     LD      (HL),A
	     INC     HL
	     LD      A,E
	     LD      B,04
     COR:    SRL     A
	     DJNZ    COR
	     ADD     A,28
	     LD      (HL),A
	     INC     HL
	     LD      A,E
	     AND     15
	     ADD     A,28
	     LD      (HL),A
	     RET     
      END _asm

DFILE_ADDR:
  db $76
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx '                                ',13
  dbzx 13
  dbzx 'F FIRE',13
  dbzx 13
  dbzx '9 CHANGE DIRECTION',13
  dbzx 13
  dbzx 13
  dbzx 13
  dbzx 13
  dbzx 13
  dbzx 13
  dbzx 13
  dbzx 13
  dbzx 13
assert (VARS_ADDR-DFILE_ADDR)>24

VARS_ADDR:
  db $80   ; end of VARS

WORKSPACE:

PROGEND: